VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5670
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8460
   LinkTopic       =   "Form1"
   ScaleHeight     =   5670
   ScaleWidth      =   8460
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrDrawPoint 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   6480
      Top             =   0
   End
   Begin VB.PictureBox picCanvas 
      BackColor       =   &H00000000&
      Height          =   5295
      Left            =   0
      ScaleHeight     =   5235
      ScaleWidth      =   8355
      TabIndex        =   4
      Top             =   360
      Width           =   8415
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   315
      Left            =   7200
      TabIndex        =   3
      Top             =   0
      Width           =   735
   End
   Begin VB.CheckBox chkDrawAxes 
      Caption         =   "Draw Axes"
      Height          =   255
      Left            =   5280
      TabIndex        =   2
      Top             =   0
      Width           =   1215
   End
   Begin VB.ComboBox cboCoefficients 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   960
      List            =   "Form1.frx":0034
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   0
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "Coefficients"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private A(0 To 11) As Double
Private X As Double
Private Y As Double

Private m_Wxmin As Double
Private m_Wxmax As Double
Private m_Wymin As Double
Private m_Wymax As Double
Private m_Wwid As Double
Private m_Whgt As Double

Private m_Wid As Double
Private m_Hgt As Double

Private Sub SetCoefficients(ByVal coefficients As String)
Const ASC_A As Integer = 65 ' Asc("A")
Dim pieces() As String
Dim coef_letters As String
Dim i As Integer

    If Len(coefficients) = 0 Then Exit Sub

    pieces = Split(coefficients, " ")
    coef_letters = UCase$(pieces(0))
    For i = 0 To 11
        A(i) = -1.2 + (Asc(Mid$(coef_letters, i + 1, 1)) - ASC_A) * 0.1
    Next i

    m_Wxmin = CDbl(pieces(1))
    m_Wxmax = CDbl(pieces(2))
    m_Wymin = CDbl(pieces(3))
    m_Wymax = CDbl(pieces(4))
    m_Wwid = m_Wxmax - m_Wxmin
    m_Whgt = m_Wymax - m_Wymin

    StartNewImage
End Sub

Private Sub StartNewImage()
Dim pix_x As Integer
Dim pix_y As Integer
Dim i As Single

    X = 0
    Y = 0

    picCanvas.Cls

    ' Draw axes is desired.
    If chkDrawAxes.Value = vbChecked Then
        pix_x = (0 - m_Wxmin) / m_Wwid * m_Wid
        pix_y = m_Hgt - (0 - m_Wymin) / m_Whgt * m_Hgt - 1
        picCanvas.Line (pix_x, 0)-Step(0, picCanvas.ScaleHeight), vbRed
        picCanvas.Line (0, pix_y)-Step(picCanvas.ScaleWidth, 0), vbRed
        For i = -5 To 5 Step 0.1
            pix_x = (i - m_Wxmin) / m_Wwid * m_Wid
            picCanvas.Line (pix_x, pix_y - 3)-Step(6, 0), &H80C0FF
        Next i
        For i = -5 To 5
            pix_x = (i - m_Wxmin) / m_Wwid * m_Wid
            pix_x = (i - m_Wxmin) / m_Wwid * m_Wid
            picCanvas.Line (pix_x, pix_y - 5)-Step(0, 10), vbYellow
        Next i

        pix_x = (0 - m_Wxmin) / m_Wwid * m_Wid
        For i = -5 To 5 Step 0.1
            pix_y = m_Hgt - (i - m_Wymin) / m_Whgt * m_Hgt - 1
            picCanvas.Line (pix_x - 3, pix_y)-Step(6, 0), &H80C0FF
        Next i
        For i = -5 To 5
            pix_y = m_Hgt - (i - m_Wymin) / m_Whgt * m_Hgt - 1
            picCanvas.Line (pix_x - 5, pix_y)-Step(10, 0), vbYellow
        Next i
    End If
End Sub

Private Sub cboCoefficients_Click()
    SetCoefficients (cboCoefficients.Text)
End Sub


Private Sub chkDrawAxes_Click()
    StartNewImage
End Sub

Private Sub cmdStart_Click()
    tmrDrawPoint.Enabled = Not tmrDrawPoint.Enabled
    If tmrDrawPoint.Enabled Then
        cmdStart.Caption = "Stop"
    Else
        cmdStart.Caption = "Start"
    End If
End Sub


Private Sub Form_Load()
    picCanvas.AutoRedraw = True

    cboCoefficients.ListIndex = 0
    SetCoefficients cboCoefficients.Text
End Sub

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    hgt = ScaleHeight - picCanvas.Top
    If hgt < 120 Then hgt = 120
    picCanvas.Move 0, picCanvas.Top, ScaleWidth, hgt

    If picCanvas.ScaleWidth <= 0 Or _
       picCanvas.ScaleHeight <= 0 Then Exit Sub

    m_Wid = picCanvas.ScaleWidth
    m_Hgt = picCanvas.ScaleHeight

    SetCoefficients cboCoefficients.Text
End Sub


Private Sub tmrDrawPoint_Timer()
Dim i As Integer
Dim new_x As Double
Dim new_y As Double
Dim pix_x As Integer
Dim pix_y As Integer

    For i = 1 To 100
        new_x = A(0) + A(1) * X + A(2) * X * X + A(3) * X * Y + A(4) * Y + A(5) * Y * Y
        new_y = A(6) + A(7) * X + A(8) * X * X + A(9) * X * Y + A(10) * Y + A(11) * Y * Y
        X = new_x
        Y = new_y

        pix_x = (X - m_Wxmin) / m_Wwid * m_Wid
        pix_y = m_Hgt - (Y - m_Wymin) / m_Whgt * m_Hgt - 1
        If (pix_x >= 0) And (pix_x < m_Wid) And _
           (pix_y >= 0) And (pix_y < m_Hgt) _
        Then
            picCanvas.PSet (pix_x, pix_y), vbBlue
        End If
    Next i
End Sub


